import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.awt.geom.Line2D;
import java.util.LinkedList;

/**
 * Eine Klasse zur Darstellung eines Graphen.
 * 
 * @author claus albowski
 * @version Juni 2015
 */
public class Graph
{
    private int breite, hoehe, anzahl;
    private String farbe;

    /**
     * Erzeuge einen neuen Graphen mit anzahl vielen Punkten
     * und zu uebergebender breite und hoehe des Fensters.
     */
    public Graph(int anzahl, int breite, int hoehe)
    {
        this.anzahl = anzahl;
        this.breite = breite;
        this.hoehe = hoehe;
        farbe = "hellgrau";
        Leinwand.gibLeinwand(breite, hoehe);
        Kante.setzeDimension(breite, hoehe);
        Knoten.setzeDimension(breite, hoehe);
        for (int i=0;i<anzahl;i++){ new Knoten(); }
    }
        
    /**
     * verknuepft alle Knoten zu einem Graphen.
     */
    public void vollstaendig(){
        Kante.loescheKanten();
        for (int i=0;i<anzahl;i++)
        for (int j=i+1;j<anzahl;j++)
        new Kante(Knoten.gibKnoten(i),Knoten.gibKnoten(j));
    }
    
    // **************** Abschnitt fuer die Grafik *****************
    /**
     * Berechnet den zu zeichnenden Graphen anhand der gegebenen Daten.
     */
    protected Shape gibAktuelleFigur()
    {
        GeneralPath graph = new GeneralPath();
        for (int i=0;i<Kante.gibAnzahl();i++){
            graph.append(Kante.gibKante(i), false);
        }
        return graph;
    }
  
    /**
     * Zeichne dieses Objekt mit seinen aktuellen Werten auf den Bildschirm.
     */
    public void zeichne()
    {
        Shape figur = gibAktuelleFigur();
        Leinwand leinwand = Leinwand.gibLeinwand();
        leinwand.zeichne (
          this,           // leinwand kennt das Objekt
          farbe,          // definiert seine Zeichenfarbe
          figur);         // definiert seinen grafischen Aspekt
    }

    /**
     * Loesche diesen Graphen vom Bildschirm.
     */
    public void loesche()
    {
        Leinwand leinwand = Leinwand.gibLeinwand();
        leinwand.entferne(this);
    }
}

