import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.Iterator;

/**
 * Die Klasse Knoten repraesentiert Knoten in einem Graphen.
 * Sie stellt auch Methoden zur Verwaltung aller Knoten bereit.
 *
 * Jeder Knoten kennt die von ihm ausgehenden Kanten
 * 
 * @author (claus albowski) 
 * @version (dez 06)
 */
public class Knoten extends Point2D.Double
{
    // Klassenvariable
    private static ArrayList<Knoten> knotenListe = new ArrayList<Knoten>();
    private static int x=300;
    private static int y=300;
    // Klassenmethode
    private static void neuerKnoten(Knoten k){ knotenListe.add(k); }
    public static void setzeDimension(int breite, int hoehe){ x=breite;y=hoehe; }
    public static Knoten gibKnoten(int i){ return knotenListe.get(i); }
    public static ArrayList<Knoten> gibAlleKnoten(){ return knotenListe; }
    // Instanzvariable fuer alle Kanten von diesem Knoten aus
    private ArrayList<Kante> kantenListe;
    private int knotenNr, xInt, yInt;
    
    /**
     * Konstruktor fuer zufaellig erzeugte Objekte der Klasse Knoten.
     */
    public Knoten() {
        super(x*Math.random(), y*Math.random());
        neuerKnoten(this);
        knotenNr = knotenListe.size();
        kantenListe = new ArrayList();
    }
    
    /**
     * Konstruktor fuer Objekte der Klasse Knoten mit vorgegebenen Werten.
     */
    public Knoten(double xPos, double yPos) {
        super(xPos, yPos);
        neuerKnoten(this);
        knotenNr = knotenListe.size();
        kantenListe = new ArrayList();
    }
    
    /**
     * gibt die Knotennummer zurueck
     */
    public int gibKnotenNummer() {return knotenNr;}
    
    /**
     * gibt die Nummer in der Knotenliste als Namen zurueck
     */
    public String toString()
    {
        int x=(int)Math.round(getX());
        int y=(int)Math.round(getY());
        return "Knoten"+knotenNr+" ("+x+"/"+y+")";

    }
    
    /**
     * nimmt eine neue Kante auf.
     */
    public void neueKante(Kante k){
        kantenListe.add(k);
    }
    
    /**
     * entfernt eine vorhandene Kante.
     */
    public void entferneKante(Kante k){
        kantenListe.remove(k);
    }
    
}
